using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Media.Imaging;
using System.Windows;


namespace ExtendSample.photo
{
    public abstract class Photo
    {

        protected string _title;
        protected string _thumbnailUrl;
        protected string _imageUrl;
        protected string _pageUrl = "";
        protected double _index;
        protected string _serviceName;
        protected string _searchWord;

        protected BitmapImage _thumbnailImage;
        protected BitmapImage _photoImage;


        public Photo()
        {
        }


        public override string ToString()
        {
            return _title.ToString();
        }



        public string Title
        {
            get
            {
                return _title;
            }
        }

        public string ThumbnailUrl
        {
            get
            {
                return _thumbnailUrl;
            }
        }

        public string ImageUrl
        {
            get
            {
                return _imageUrl;
            }
        }

        public string PageUrl
        {
            get
            {
                return _pageUrl;
            }
        }

        public double Index
        {
            get
            {
                return _index;
            }
            set
            {
                _index = value;
            }
        }

        public string ServiceName
        {
            get
            {
                return _serviceName;
            }
            set
            {
                _serviceName = value;
            }
        }

        public string SearchWord
        {
            get
            {
                return _searchWord;
            }
            set
            {
                _searchWord = value;
            }
        }



        public BitmapImage ThumbnailImage
        {
            get
            {
                return _thumbnailImage;
            }
        }

        public BitmapImage PhotoImage
        {
            get
            {
                return _photoImage;
            }
        }



        public virtual string GetOpenPageUrl()
        {
            return _pageUrl;
        }



        private BitmapImage SetPhotoBitmapImage(String imagePath)
        {
            BitmapImage bitmapImage = new BitmapImage();
            try
            {
                bitmapImage.BeginInit();

                Uri uri = new Uri(imagePath, UriKind.Absolute);
                bitmapImage.UriSource = uri;
                bitmapImage.EndInit();
            }
            catch (Exception e)
            {
                MessageBox.Show(e.ToString());
            }

            return bitmapImage;
        }



        protected BitmapImage GetThumbnailBitmap()
        {
            if (_thumbnailImage == null)
            {
                BitmapImage bmp = SetPhotoBitmapImage(_thumbnailUrl);
                _thumbnailImage = bmp;
            }

            return _thumbnailImage;
        }



        public BitmapImage GetBitmap()
        {
            if (_photoImage == null)
            {
                BitmapImage bmp = SetPhotoBitmapImage(_imageUrl);
                _photoImage = bmp;
            }

            return _photoImage;
        }


    }
}
