using System;
using System.Collections.Generic;
using System.Text;

using System.Windows;
using System.Net;
using System.Xml;
using System.Collections.ObjectModel;

using ExtendSample.photo;


namespace ExtendSample.service.hatena
{
    class Hatena : IService
    {
        public const string SERVICE_BASE = "͂ĂȃtHgCt";

        private const string API_BASE_URL = "http://f.hatena.ne.jp/t/";
        private const string HATENA_SEARCH_RSS = "?mode=rss";


        static Hatena()
        {
        }


        /// <summary>
        /// 
        /// </summary>
        /// <param name="searchWord"></param>
        /// <returns></returns>
        public Collection<Photo> Send(string searchWord)
        {
            Collection<Photo> responseCollenction = new Collection<Photo>();

            int indexCounter = -1;

            string sendUrl = GetSearchUrl(searchWord);


            try
            {

                WebRequest request = WebRequest.Create(sendUrl);
                WebResponse response = request.GetResponse();


                using (XmlTextReader responseReader = new XmlTextReader(response.GetResponseStream()))
                {
                    while (responseReader.Read())
                    {
                        if ((responseReader.IsStartElement()) && ("item" == responseReader.LocalName))
                        {
                            string titleValue = "";
                            string imageUrlValue = "";
                            string smallImageUrlValue = "";
                            string linkUrlValue = "";

                            //݂̃m[hтׂ̂Ă̎qm[hǂݎ
                            using (XmlReader itemReader = responseReader.ReadSubtree())
                            {
                                while (itemReader.Read())
                                {

                                    if (itemReader.IsStartElement())
                                    {
                                        if ("title" == itemReader.LocalName)
                                        {
                                            titleValue = itemReader.ReadElementContentAsString();
                                        }
                                        else if ("imageurl" == itemReader.LocalName)
                                        {
                                            imageUrlValue = itemReader.ReadElementContentAsString();
                                        }
                                        else if ("imageurlsmall" == itemReader.LocalName)
                                        {
                                            smallImageUrlValue = itemReader.ReadElementContentAsString();
                                        }
                                        else if ("link" == itemReader.LocalName)
                                        {
                                            linkUrlValue = itemReader.ReadElementContentAsString();
                                        }

                                    }

                                }//while end

                            }//using end

                            indexCounter++;

                            HatenaPhoto photo = new HatenaPhoto(titleValue, smallImageUrlValue, imageUrlValue, linkUrlValue, indexCounter, SERVICE_BASE, searchWord);

                            responseCollenction.Add(photo);
                        }

                    }//while end

                }//using end
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

            return responseCollenction;

        }


        public string GetServiceName()
        {
            string serviceName = SERVICE_BASE;
            return serviceName;
        }


        private string GetSearchUrl(string searchWord)
        {
            string urlString = "";

            urlString = API_BASE_URL;
            urlString += searchWord;
            urlString += HATENA_SEARCH_RSS;
            return urlString;
        }

    }
}
