using System;
using System.Collections.Generic;
using System.Text;

using System.Net;
using System.Xml;
using System.Collections.ObjectModel;

using ExtendSample.photo;


namespace ExtendSample.service.hotpepper
{
    class HotPepper : IService
    {
        public const string SERVICE_BASE = "zbgybp[";

        private const string API_BASE_URL = "http://api.hotpepper.jp/GourmetSearch/V110";
        private const string HOTPEPPER_API_KEY = "?key=guest&";

        public HotPepper()
        {
        }


        public Collection<Photo> Send(string searchWord)
        {
            Collection<Photo> responseCollenction = new Collection<Photo>();

            int indexCounter = -1;

            string sendUrl = GetSearchUrl(searchWord);

            WebRequest request = WebRequest.Create(sendUrl);
            WebResponse response = request.GetResponse();


            using (XmlTextReader responseReader = new XmlTextReader(response.GetResponseStream()))
            {
                while (responseReader.Read())
                {
                    if ((responseReader.IsStartElement()) && ("Shop" == responseReader.LocalName))
                    {
                        string titleValue = "";
                        string imageUrlValue = "";
                        string smallImageUrlValue = "";
                        string linkUrlValue = "";

                        //݂̃m[hтׂ̂Ă̎qm[hǂݎ
                        using (XmlReader itemReader = responseReader.ReadSubtree())
                        {
                            while (itemReader.Read())
                            {

                                if (itemReader.IsStartElement())
                                {
                                    if ("ShopName" == itemReader.LocalName)
                                    {
                                        titleValue = itemReader.ReadElementContentAsString();
                                    }
                                    else if ("PcLargeImg" == itemReader.LocalName)
                                    {
                                        imageUrlValue = itemReader.ReadElementContentAsString();
                                    }
                                    else if ("PcSmallImg" == itemReader.LocalName)
                                    {
                                        smallImageUrlValue = itemReader.ReadElementContentAsString();
                                    }
                                    else if ("ShopUrl" == itemReader.LocalName)
                                    {
                                        linkUrlValue = itemReader.ReadElementContentAsString();
                                    }

                                }

                            }//while end

                        }//using end

                        indexCounter++;

                        HatenaPhoto photo = new HatenaPhoto(titleValue, smallImageUrlValue, imageUrlValue, linkUrlValue, indexCounter, SERVICE_BASE, searchWord);

                        responseCollenction.Add(photo);
                    }

                }//while end

            }//using end

            return responseCollenction;

        }



        public string GetServiceName()
        {
            string serviceName = SERVICE_BASE;
            return serviceName;
        }

        private string GetSearchUrl(string searchWord)
        {
            string urlString = "";

            urlString = API_BASE_URL;
            urlString += HOTPEPPER_API_KEY;
            urlString += "Keyword=" + searchWord;
            urlString += "&Count=60";
            return urlString;
        }
    }
}
