using System;
using System.Collections.Generic;
using System.Text;

using System.Windows;
using System.Net;
using System.Xml;
using System.Collections.ObjectModel;

using ExtendSample.photo;

namespace ExtendSample.service.photozou
{
    class Photozou : IService
    {

        //public const string SERVICE_BASE = "PHOTOZOU";
        public const string SERVICE_BASE = "tHg";

        private const string API_BASE_URL = "http://api.photozou.jp/rest/search_public&type=photo&";
        private const string OTHER_PARAM= "&limit=60";

        public  Photozou()
        {
        }


        public Collection<Photo> Send(string searchWord)
        {
            Collection<Photo> responseCollenction = new Collection<Photo>();

            int indexCounter = -1;

            string sendUrl = GetSearchUrl(searchWord);
            try
            {
                WebRequest request = WebRequest.Create(sendUrl);
                WebResponse response = request.GetResponse();


                using (XmlTextReader responseReader = new XmlTextReader(response.GetResponseStream()))
                {
                    while (responseReader.Read())
                    {
                        if ((responseReader.IsStartElement()) && ("photo" == responseReader.LocalName))
                        {
                            string titleValue = "";
                            string imageUrlValue = "";
                            string smallImageUrlValue = "";
                            string linkUrlValue = "";

                            //݂̃m[hтׂ̂Ă̎qm[hǂݎ
                            using (XmlReader itemReader = responseReader.ReadSubtree())
                            {
                                while (itemReader.Read())
                                {

                                    if (itemReader.IsStartElement())
                                    {
                                        if ("photo_title" == itemReader.LocalName)
                                        {
                                            titleValue = itemReader.ReadElementContentAsString();
                                        }
                                        else if ("image_url" == itemReader.LocalName)
                                        {
                                            imageUrlValue = itemReader.ReadElementContentAsString();

                                        }
                                        else if ("thumbnail_image_url" == itemReader.LocalName)
                                        {
                                            smallImageUrlValue = itemReader.ReadElementContentAsString();
                                        }
                                        else if ("url" == itemReader.LocalName)
                                        {
                                            linkUrlValue = itemReader.ReadElementContentAsString();

                                        }

                                    }

                                }//while end

                            }//using end

                            indexCounter++;

                            PhotozouPhoto photo = new PhotozouPhoto(titleValue, smallImageUrlValue, imageUrlValue, linkUrlValue, indexCounter, SERVICE_BASE, searchWord);

                            responseCollenction.Add(photo);

                        }

                    }//while end

                }//using end
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

            return responseCollenction;

        }



        public string GetServiceName()
        {
            string serviceName = SERVICE_BASE;
            return serviceName;
        }


        private string GetSearchUrl(string searchWord)
        {
            string urlString = "";

            urlString = API_BASE_URL;
            urlString += "keyword=" + searchWord;
            urlString += OTHER_PARAM;
            return urlString;
        }





    }
}
