using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using System.Windows.Media.Animation;

using ExtendSample.photo;


namespace ExtendSample.view
{
    /// <summary>
    /// Interaction logic for MyListPanel.xaml
    /// </summary>

    public partial class MyListPanel : System.Windows.Controls.UserControl
    {

        #region JX^RoutedEvent

        #region XgICxguPhotoSelectedv

        /// <summary>
        /// JX^RoutedEventiXgICxgjuPhotoSelectedv쐬
        /// </summary>
        public static readonly RoutedEvent PhotoSelectedEvent = EventManager.RegisterRoutedEvent("PhotoSelected", RoutingStrategy.Bubble, typeof(RoutedEventHandler), typeof(MyListPanel));

        // Provide CLR accessors for the event
        public event RoutedEventHandler PhotoSelected
        {
            add { AddHandler(PhotoSelectedEvent, value); }
            remove { RemoveHandler(PhotoSelectedEvent, value); }
        }

        // This method raises
        private void RaisePhotoSelectedEvent()
        {
            RoutedEventArgs newEventArgs = new RoutedEventArgs(MyListPanel.PhotoSelectedEvent);
            RaiseEvent(newEventArgs);
        }

        #endregion

        #endregion


        private const string DATA_RESOURCE_NAME = "MyPhotoData_ODP";

        private PhotoDataCollection myCollectionData;
        private Photo selectedPhoto = null;
        private int selectPhotoNumber;


        #region vpeB

        /// <summary>
        /// I摜
        /// </summary>
        public Photo SelectedPhoto
        {
            get
            {
                return selectedPhoto;
            }
        }

        /// <summary>
        /// RNVI摜ԍ
        /// </summary>
        public int SelectPhotoNumber
        {
            get
            {
                return selectPhotoNumber;
            }
        }

        /// <summary>
        /// RNV
        /// </summary>
        public PhotoDataCollection MyCollectionData
        {
            get
            {
                return myCollectionData;
            }
        }


        #endregion


        /// <summary>
        /// RXgN^
        /// </summary>
        public MyListPanel()
        {
            InitializeComponent();
        }


        #region Cxgnh

        /// <summary>
        ///  MyListPanel[h@Cxgnh
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void userControl_Loaded(object sender, RoutedEventArgs e)
        {
            myCollectionData = new PhotoDataCollection();
            myCollectionData = GetCollectionResource();
        }


        /// <summary>
        /// TlCIiPhotoViewer\)
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void myPhotoListBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            ListBox myList = (ListBox)sender;
            Photo photo = (Photo)myList.SelectedItem;
            int selectedNumber = myList.SelectedIndex;

            if (photo != null)
            {
                selectedPhoto = photo;
                selectPhotoNumber = selectedNumber;

                //XgICxguPhotoSelectedv
                RaisePhotoSelectedEvent();

                myPhotoListBox.SelectedItem = null;
            }
        }


        /// <summary>
        /// TlC{^NbNiMyList폜j
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void removeButton_Click(object sender, RoutedEventArgs e)
        {
            Button btn = (Button)sender;
            Grid gr = (Grid)btn.Parent;

            ListBoxItem selectItem = (ListBoxItem)gr.TemplatedParent;
            Photo photo = (Photo)selectItem.DataContext;

            myCollectionData.Remove(photo);
        }

        #endregion


        #region private Method

        /// <summary>
        /// ObjectDataProvider擾
        /// </summary>
        /// <returns></returns>
        private PhotoDataCollection GetCollectionResource()
        {
            ObjectDataProvider dataSource = (ObjectDataProvider)this.FindResource(DATA_RESOURCE_NAME);
            PhotoDataCollection collectionData = (PhotoDataCollection)dataSource.Data;

            return collectionData;
        }


        #endregion



        #region Method

        /// <summary>
        /// TlC摜ǉ
        /// </summary>
        /// <param name="photo"></param>
        public void AddPhoto(Photo photo)
        {
            bool isContains = myCollectionData.Contains(photo);
            if (isContains)
            {
                int containInt = myCollectionData.IndexOf(photo);
                myCollectionData.Move(containInt, 0);
            }
            else
            {
                myCollectionData.Insert(0, photo);
            }

            myPhotoListBox.ScrollIntoView(photo);
        }


        /// <summary>
        /// plI[vNiTlC摜ǉj
        /// </summary>
        public void OpenAnimation()
        {
            Storyboard sb = (Storyboard)this.FindResource("Timeline_open");
            this.BeginStoryboard(sb);
        }

        #endregion

    }
}