using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using System.Collections.ObjectModel;
using System.Windows.Media.Animation;

using ExtendSample.photo;


namespace ExtendSample.view
{
    /// <summary>
    /// Interaction logic for PhotoCircle.xaml
    /// </summary>

    public partial class PhotoCircle : System.Windows.Controls.UserControl
    {

        #region JX^RoutedEvent

        #region AjICxguOpenAnimmeCompletedv

        /// <summary>
        /// JX^RoutedEventiAjICxgjuOpenAnimmeCompletedv쐬
        /// </summary>
        public static readonly RoutedEvent OpenAnimmeCompletedEvent = EventManager.RegisterRoutedEvent("OpenAnimmeCompleted", RoutingStrategy.Bubble, typeof(RoutedEventHandler), typeof(PhotoCircle));

        // Provide CLR accessors for the event
        public event RoutedEventHandler OpenAnimmeCompleted
        {
            add { AddHandler(OpenAnimmeCompletedEvent, value); }
            remove { RemoveHandler(OpenAnimmeCompletedEvent, value); }
        }

        // This method raises
        private void RaiseOpenAnimmeCompletedEvent()
        {
            RoutedEventArgs newEventArgs = new RoutedEventArgs(PhotoCircle.OpenAnimmeCompletedEvent);
            RaiseEvent(newEventArgs);
        }

        #endregion


        #region kCxguCircleSmallCompletedv

        /// <summary>
        /// JX^RoutedEventikCxgjuCircleSmallCompletedv쐬
        /// </summary>
        public static readonly RoutedEvent CircleSmallCompletedEvent = EventManager.RegisterRoutedEvent("CircleSmallCompleted", RoutingStrategy.Bubble, typeof(RoutedEventHandler), typeof(PhotoCircle));

        // Provide CLR accessors for the event
        public event RoutedEventHandler CircleSmallCompleted
        {
            add { AddHandler(CircleSmallCompletedEvent, value); }
            remove { RemoveHandler(CircleSmallCompletedEvent, value); }
        }

        // This method raises
        private void RaiseCircleSmallCompletedEvent()
        {
            RoutedEventArgs newEventArgs = new RoutedEventArgs(PhotoCircle.CircleSmallCompletedEvent);
            RaiseEvent(newEventArgs);
        }

        #endregion


        #region {^NbNCxguCloseCircleClickedv

        /// <summary>
        /// JX^RoutedEventi{^NbNCxgjuCloseCircleClickedv쐬
        /// </summary>
        public static readonly RoutedEvent CloseCircleClickedEvent = EventManager.RegisterRoutedEvent("CloseCircleClicked", RoutingStrategy.Bubble, typeof(RoutedEventHandler), typeof(PhotoCircle));

        // Provide CLR accessors for the event
        public event RoutedEventHandler CloseCircleClicked
        {
            add { AddHandler(CloseCircleClickedEvent, value); }
            remove { RemoveHandler(CloseCircleClickedEvent, value); }
        }

        // This method raises
        private void RaiseCloseCircleClickedEvent()
        {
            RoutedEventArgs newEventArgs = new RoutedEventArgs(PhotoCircle.CloseCircleClickedEvent);
            RaiseEvent(newEventArgs);
        }

        #endregion


        #region XgICxguPhotoSelectedv

        /// <summary>
        /// JX^RoutedEventiXgICxgjuPhotoSelectedv쐬
        /// </summary>
        public static readonly RoutedEvent PhotoSelectedEvent = EventManager.RegisterRoutedEvent("PhotoSelected", RoutingStrategy.Bubble, typeof(RoutedEventHandler), typeof(PhotoCircle));

        // Provide CLR accessors for the event
        public event RoutedEventHandler PhotoSelected
        {
            add { AddHandler(PhotoSelectedEvent, value); }
            remove { RemoveHandler(PhotoSelectedEvent, value); }
        }

        // This method raises
        private void RaisePhotoSelectedEvent()
        {
            RoutedEventArgs newEventArgs = new RoutedEventArgs(PhotoCircle.PhotoSelectedEvent);
            RaiseEvent(newEventArgs);
        }

        #endregion


        #region PhotoCircleICxguSmallCircleSelectedv

        /// <summary>
        /// JX^RoutedEventiPhotoCircleICxgjuSmallCircleSelectedv쐬
        /// </summary>
        public static readonly RoutedEvent SmallCircleSelectedEvent = EventManager.RegisterRoutedEvent("SmallCircleSelected", RoutingStrategy.Bubble, typeof(RoutedEventHandler), typeof(PhotoCircle));

        // Provide CLR accessors for the event
        public event RoutedEventHandler SmallCircleSelected
        {
            add { AddHandler(SmallCircleSelectedEvent, value); }
            remove { RemoveHandler(SmallCircleSelectedEvent, value); }
        }

        // This method raises
        private void RaiseSmallCircleSelectedEvent()
        {
            RoutedEventArgs newEventArgs = new RoutedEventArgs(PhotoCircle.SmallCircleSelectedEvent);
            RaiseEvent(newEventArgs);
        }

        #endregion


        #region XgACe{^NbNCxguAddMyListButtonClickedv

        /// <summary>
        /// JX^RoutedEventiXgACe{^NbNCxgjuAddMyListButtonClickedv쐬
        /// </summary>
        public static readonly RoutedEvent AddMyListButtonClickedEvent = EventManager.RegisterRoutedEvent("AddMyListButtonClicked", RoutingStrategy.Bubble, typeof(RoutedEventHandler), typeof(PhotoCircle));

        // Provide CLR accessors for the event
        public event RoutedEventHandler AddMyListButtonClicked
        {
            add { AddHandler(AddMyListButtonClickedEvent, value); }
            remove { RemoveHandler(AddMyListButtonClickedEvent, value); }
        }

        // This method raises
        private void RaiseAddMyListButtonClickedEvent()
        {
            RoutedEventArgs newEventArgs = new RoutedEventArgs(PhotoCircle.AddMyListButtonClickedEvent);
            RaiseEvent(newEventArgs);
        }

        #endregion

        #endregion


        private const uint LIST_SHOW_VALUE = 12;
        private const string DATA_RESOURCE_NAME = "PhotoData_ODP";

        private readonly string ServiceName;
        private readonly string SearchWord;
        private readonly int MaxPagingNumber;


        public readonly Collection<Photo> ResultCollection;

        private Photo selectedPhoto = null;
        private int selectPhotoNumber;


        private PhotoDataCollection showingCollection;
        private int nowPagingNumber;

        private Storyboard smallMouseDownAnime;
        private Storyboard smallMouseLeaveAnime;


        #region vpeB

        /// <summary>
        /// I摜
        /// </summary>
        public Photo SelectedPhoto
        {
            get
            {
                return selectedPhoto;
            }
        }

        /// <summary>
        /// RNVI摜ԍ
        /// </summary>
        public int SelectPhotoNumber
        {
            get
            {
                return selectPhotoNumber;
            }
        }

        #endregion


        #region RXgN^

        /// <summary>
        /// RXgN^
        /// </summary>
        public PhotoCircle()
        {
            InitializeComponent();

            selectPhotoNumber = 0;
            nowPagingNumber = 0;
        }


        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="resultCollection">ʃRNV</param>
        /// <param name="serviceName">T[rX</param>
        /// <param name="searchWord">L[[h</param>
        public PhotoCircle(Collection<Photo> resultCollection, string serviceName, string searchWord): this()
        {            
            //Initialize Collection
            showingCollection = new PhotoDataCollection();
            ResultCollection = new Collection<Photo>();

            ResultCollection = resultCollection;
            ServiceName = serviceName;
            SearchWord = searchWord;


            int totalCount = ResultCollection.Count - 1;
            double page = totalCount / LIST_SHOW_VALUE;
            MaxPagingNumber = (int)Math.Floor(page) + 1;
        }

        #endregion


        #region Cxgnh

        /// <summary>
        /// PhotoCircle[h@Cxgnh
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            Storyboard openAnime = (Storyboard)this.FindResource("Timeline_show");
            openAnime.Completed += new EventHandler(OpenAnime_Completed);

            Storyboard smallAnime = (Storyboard)this.FindResource("Timeline_small");
            smallAnime.Completed += new EventHandler(SmallAnime_Completed);


            smallMouseDownAnime = new Storyboard();
            smallMouseLeaveAnime = new Storyboard();

            smallMouseDownAnime = (Storyboard)this.FindResource("Timeline_smallMouseDown");
            smallMouseDownAnime.Completed += new EventHandler(SmallMouseDownAnime_Completed);

            smallMouseLeaveAnime = (Storyboard)this.FindResource("Timeline_smallMouseLeave");



            showingCollection = GetCollectionResource();

            //T[rX\
            serviceLabel.Content = ServiceName;

            //L[[h\
            wordLabel.Content = SearchWord;

            ChangeThumbnailPage();
        }


        #region Aj[Vn@Cxgnh

        /// <summary>
        /// TlCT[NoAjI@Cxgnh
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void OpenAnime_Completed(object sender, EventArgs e)
        {
            //AjICxguOpenAnimmeCompletedv
            RaiseOpenAnimmeCompletedEvent();
        }


        /// <summary>
        /// TlCT[NkAjI@Cxgnh
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void SmallAnime_Completed(object sender, EventArgs e)
        {
            //kCxguCircleSmallCompletedv
            RaiseCircleSmallCompletedEvent();

            thumbnailListBox.IsHitTestVisible = false;
            bigHitEllipse.Visibility = Visibility.Collapsed;
            serviceNameGrid.Visibility = Visibility.Hidden;
            pagingStackPanel.Visibility = Visibility.Hidden;

            smallHitEllipse.Visibility = Visibility.Visible;

            //{^\ꂽ܂܂ȂAx
            if (closeButton.Visibility != Visibility.Hidden)
            {
                Storyboard sb = (Storyboard)this.FindResource("Timeline_mouseLeave");
                this.BeginStoryboard(sb);
            }
        }

        /// <summary>
        /// OTlCT[N}EX_EAjI@Cxgnh
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void SmallMouseDownAnime_Completed(object sender, EventArgs e)
        {
            thumbnailListBox.IsHitTestVisible = true;
            bigHitEllipse.Visibility = Visibility.Visible;
            serviceNameGrid.Visibility = Visibility.Visible;
            pagingStackPanel.Visibility = Visibility.Visible;

            smallHitEllipse.Visibility = Visibility.Collapsed;
        }


        /// <summary>
        /// TlCT[N}EX_EAjI@Cxgnh
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void smallHitEllipse_MouseDown(object sender, MouseButtonEventArgs e)
        {
            //PhotoCircleICxguSmallCirclePhotoSelectedv
            RaiseSmallCircleSelectedEvent();

            SwapCircle();
        }

        #endregion


        #region {^Cxgnh


        /// <summary>
        /// TlCT[N{^NbN@Cxgnh
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void CloseButton_Click(object sender, RoutedEventArgs e)
        {
            // {^NbNCxguCloseCircleClickedv
            RaiseCloseCircleClickedEvent();
        }

        /// <summary>
        /// Oy[W{^NbN@Cxgnh
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void PrevPageButton_Click(object sender, RoutedEventArgs e)
        {
            nowPagingNumber--;
            ChangeThumbnailPage();
        }

        /// <summary>
        /// y[W{^NbN@Cxgnh
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void NextPageButton_Click(object sender, RoutedEventArgs e)
        {
            nowPagingNumber++;
            ChangeThumbnailPage();
        }


        #endregion


        /// <summary>
        /// TlCIiPhotoViewer\)
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void thumbnailListBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            ListBox circle = (ListBox)sender;
            Photo photo = (Photo)circle.SelectedItem;

            if (photo != null)
            {
                selectedPhoto = photo;

                selectPhotoNumber = (int)photo.Index;

                //XgICxguPhotoSelectedv
                RaisePhotoSelectedEvent();

                circle.SelectedIndex = -1;
            }
        }


        /// <summary>
        /// TlC{^NbNiMyList֒ǉj
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void addMylistButton_Click(object sender, RoutedEventArgs e)
        {
            Button btn = (Button)sender;
            Grid gr = (Grid)btn.Parent;

            ListBoxItem selectItem = (ListBoxItem)gr.TemplatedParent;
            Photo photo = (Photo)selectItem.DataContext;

            selectedPhoto = photo;

            //XgACe{^NbNCxguAddMyListButtonClickedv
            RaiseAddMyListButtonClickedEvent();
        }

        #endregion


        #region private Method

        /// <summary>
        /// ObjectDataProvider擾
        /// </summary>
        /// <returns></returns>
        private PhotoDataCollection GetCollectionResource()
        {
            ObjectDataProvider dataSource = (ObjectDataProvider)this.FindResource(DATA_RESOURCE_NAME);
            PhotoDataCollection collectionData = (PhotoDataCollection)dataSource.Data;

            return collectionData;
        }


        /// <summary>
        /// TlCy[W؂ւ
        /// </summary>
        private void ChangeThumbnailPage()
        {
            SetPagingLabel();
            SyncPagingButton();
            SetPageShowingCollection(nowPagingNumber);
        }


        /// <summary>
        /// y[W\
        /// </summary>
        private void SetPagingLabel()
        {
            string nowPageString = (nowPagingNumber + 1).ToString();
            string maxPageString = MaxPagingNumber.ToString();
            pagingLabel.Content = nowPageString + "/" + maxPageString;

            int resultCount = ResultCollection.Count;
            if (resultCount == 0)
            {
                pagingLabel.Content = "0/0";
            }
        }


        /// <summary>
        /// y[Wɍ킹ă{^\𓯊
        /// </summary>
        private void SyncPagingButton()
        {
            prevPageButton.Visibility = Visibility.Visible;
            nextPageButton.Visibility = Visibility.Visible;

            if (nowPagingNumber <= 0)
            {
                prevPageButton.Visibility = Visibility.Hidden;
            }
            if (nowPagingNumber >= MaxPagingNumber - 1)
            {
                nextPageButton.Visibility = Visibility.Hidden;
            }
        }


        /// <summary>
        /// y[Wɍ킹ListboxpRNV̒gւ
        /// </summary>
        /// <param name="pageCount"></param>
        private void SetPageShowingCollection(int pageCount)
        {
            showingCollection.Clear();

            int resultCount = ResultCollection.Count;

            int startIndex = (int)(pageCount * LIST_SHOW_VALUE);
            int endIndex = (int)((pageCount + 1) * LIST_SHOW_VALUE - 1);

            //ʂ12菭Ȃꍇ
            if (resultCount - 1 < endIndex)
            {
                endIndex = resultCount - 1;
            }

            //gւ
            for (int i = startIndex; i <= endIndex; i++)
            {
                Photo showPhoto = (Photo)ResultCollection[i];
                showingCollection.Add(showPhoto);
            }
        }

        #endregion


        #region Method

        /// <summary>
        /// TlCT[Nk
        /// </summary>
        public void Small()
        {
            thumbnailListBox.IsHitTestVisible = false;
            bigHitEllipse.Visibility = Visibility.Collapsed;
            serviceNameGrid.Visibility = Visibility.Hidden;
            pagingStackPanel.Visibility = Visibility.Hidden;

            smallHitEllipse.Visibility = Visibility.Visible;


            Storyboard smallAnime = (Storyboard)this.FindResource("Timeline_small");
            this.BeginStoryboard(smallAnime);

            Storyboard mouseLeaveAnime = (Storyboard)this.FindResource("Timeline_mouseLeave");
            this.BeginStoryboard(mouseLeaveAnime);
        }


        /// <summary>
        /// \TlCT[N]
        /// </summary>
        /// <param name="index"></param>
        public void ArchivalRotate(int index)
        {
            double animateDuration = (1 + index) * 200;

            Storyboard sb = (Storyboard)this.FindResource("Timeline_rotate");
            TimelineCollection tCollection = (TimelineCollection)sb.Children;

            DoubleAnimation outerRotateAnime = (DoubleAnimation)tCollection[0];
            outerRotateAnime.Duration = new Duration(TimeSpan.FromMilliseconds(animateDuration));
            outerRotateAnime.To = (360 / LIST_SHOW_VALUE) * index;

            DoubleAnimation innerRotateAnime = (DoubleAnimation)tCollection[1];
            innerRotateAnime.Duration = new Duration(TimeSpan.FromMilliseconds(animateDuration));
            innerRotateAnime.To = -(360 / LIST_SHOW_VALUE) * index;

            this.BeginStoryboard(sb);
        }


        /// <summary>
        /// ~TlCT[N]
        /// </summary>
        /// <param name="index"></param>
        public void Rotate(int index)
        {
            double animateDuration = 1000;

            Storyboard sb = (Storyboard)this.FindResource("Timeline_rotate");
            TimelineCollection tCollection = (TimelineCollection)sb.Children;

            DoubleAnimation outerRotateAnime = (DoubleAnimation)tCollection[0];
            outerRotateAnime.Duration = new Duration(TimeSpan.FromMilliseconds(animateDuration));
            outerRotateAnime.To = (360 / LIST_SHOW_VALUE) * index;

            DoubleAnimation innerRotateAnime = (DoubleAnimation)tCollection[1];
            innerRotateAnime.Duration = new Duration(TimeSpan.FromMilliseconds(animateDuration));
            innerRotateAnime.To = -(360 / LIST_SHOW_VALUE) * index;

            this.BeginStoryboard(sb);
        }


        /// <summary>
        /// TlCT[Nւ
        /// </summary>
        public void SwapCircle()
        {   
            //ɖ߂Aj[V
            this.BeginStoryboard(smallMouseDownAnime);

            //TlCT[Ñ}EXI[o[
            this.BeginStoryboard(smallMouseLeaveAnime);
        }


        /// <summary>
        /// TlCT[N̊px擾
        /// </summary>
        /// <returns></returns>
        public double GetUserControlAngle()
        {
            TransformGroup transform = (TransformGroup)this.RenderTransform;
            RotateTransform rotate = (RotateTransform)transform.Children[2];
            double angle = rotate.Angle;

            return angle;
        }

        #endregion


    }
}