using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using System.Windows.Media.Animation;
using System.Windows.Media.Media3D;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.Windows.Threading;

using ExtendSample.photo;


namespace ExtendSample.view
{
    /// <summary>
    /// Interaction logic for PhotoViewer.xaml
    /// </summary>

    public partial class PhotoViewer : System.Windows.Controls.UserControl
    {

        //3DIuWFNg
        private const string MODEL_GROUP_BASE_NAME = "photoGroup3D_";
        private const string MODEL_BASE_NAME = "PanelGeometry_";
        private const int BASE_CENTER_MODEL_NUMBER = 12;
        private const int MAX_PANEL_COUNT = 24;

        //plgkTCY
        private const double MODEL_DEFALUT_SCALE = 0.8;
        private const double MODEL_BIG_SCALE = 2.0;

        //3D]pl
        private const double BASE_OFFSET_Y = 1.5;
        private const double BASE_ANGLE = 30;

        //qbgeXgXN[p^C}[ tick^C
        private const double SWITCHING_TIMER_SPAN = 100;



        //T[rX or My List
        private string listPattern = "";

        //\pRNV
        private Collection<Photo> viewPhotoCollection = null;
        //I𒆂̃RNV摜ԍ
        private int nowSelectNumber = 0;



        //I𒆂̉摜\Ă郂fԍǗ(0`23)
        private int modelSelectNumber = 0;

        //Ẻ摜؂ւ񐔂Ǘi]pxɎgpj
        private int scrollCount = 0;

        //qbgeXgŃXN[񐔂Ǘ
        private int hitTestScrollValue = 0;

        //[v\pɏ㉺փ[vpWړ郂fԍǗ
        private int moveNumber = 0;


        /// <summary>
        /// RXgN^
        /// </summary>
        public PhotoViewer()
        {
            InitializeComponent();

            viewPhotoCollection = new Collection<Photo>();
        }


        #region Cxgnh

        /// <summary>
        /// Viewport3DɃqbgeXgݒ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void viewerViewport3D_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            Point mousePosition = e.GetPosition(viewerViewport3D);
            PointHitTestParameters pointParams = new PointHitTestParameters(mousePosition);
            VisualTreeHelper.HitTest(viewerViewport3D, null, HTResultCallback, pointParams);
        }


        #region {^@Cxgnh

        /// <summary>
        /// 摜\{^NbN@Cxgnh
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void nextButton_Click(object sender, RoutedEventArgs e)
        {
            ChangeToNextPhoto();
        }


        /// <summary>
        /// O摜\{^NbN@Cxgnh
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void pervButton_Click(object sender, RoutedEventArgs e)
        {
            ChangeToPrevPhoto();
        }


        /// <summary>
        /// {^NbN@Cxgnh
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void closeButton_Click(object sender, RoutedEventArgs e)
        {
            this.Visibility = Visibility.Hidden;
            viewPhotoCollection = null;

            ClearAllPanelBrush();

            ResetContainerScale();
            ResetContainerOffsetY();

            moveNumber = 0;
        }


        /// <summary>
        /// uEUJ{^NbN@Cxgnh
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void openPageButton_Click(object sender, RoutedEventArgs e)
        {
            Photo photo = (Photo)viewPhotoCollection[nowSelectNumber];

            string openPageUrl = photo.GetOpenPageUrl();

            //Check http
            int urlIndex = openPageUrl.IndexOf("http://");

            if (urlIndex.Equals(0))
            {
                Process.Start(new ProcessStartInfo(openPageUrl));
                e.Handled = true;
            }
        }

        #endregion

        #endregion


        #region private Method

        /// <summary>
        /// I𒆉摜̏ڍ׃eLXg\
        /// </summary>
        private void SetPhotoText()
        {
            Photo photo = viewPhotoCollection[nowSelectNumber];

            string serviceString = photo.ServiceName;
            string searchString = photo.SearchWord;
            string titleString = photo.Title;

            //t[iSearch or My List > T[rX > L[[hj
            resultLabel.Content = listPattern + " > " + serviceString + " > " + searchString;

            //摜^Cg
            titleLabel.Content = titleString;
            if (titleString == "")
            {
                titleLabel.Content = "untitled";
            }

            //Iԍ\iԍ/j
            int collectionCount = viewPhotoCollection.Count;
            int pageValue = nowSelectNumber + 1;
            pagingLabel.Content = pageValue.ToString() + " / " + collectionCount.ToString();
        }


        /// <summary>
        /// 3DWJ̃Aj[V
        /// </summary>
        /// <param name="startIndex"></param>
        /// <param name="endIndex"></param>
        private void OpenTornadoAnimation(int startIndex, int endIndex)
        {
            //plɉ摜\
            SetPanelPhoto();

            //storyboard
            Storyboard sb = (Storyboard)this.FindResource("Timeline_open");
            TimelineCollection tCollection = (TimelineCollection)sb.Children;

            //rotation
            Rotation3DAnimation rotateAnime = (Rotation3DAnimation)tCollection[0];

            AxisAngleRotation3D angleRotationFrom = (AxisAngleRotation3D)rotateAnime.From;
            angleRotationFrom.Angle = (BASE_ANGLE * startIndex) - 180;

            AxisAngleRotation3D angleRotationTo = (AxisAngleRotation3D)rotateAnime.To;
            angleRotationTo.Angle = -(BASE_ANGLE * endIndex) / 2;

            //offsetY
            DoubleAnimation offsetYAnime = (DoubleAnimation)tCollection[1];

            offsetYAnime.From = BASE_OFFSET_Y * startIndex;
            offsetYAnime.To = BASE_OFFSET_Y * endIndex;

            this.BeginStoryboard(sb);
        }


        /// <summary>
        /// 3Dɉ摜Kp
        /// </summary>
        private void SetPanelPhoto()
        {
            //PanelGeometry_0`23p
            int geoModelNumber = 0;

            //RNV
            int collectionCount = viewPhotoCollection.Count;

            //̑I摜ɂPanelGeometry_0Yԍi-12`47j
            int startPhotoIndex = nowSelectNumber - BASE_CENTER_MODEL_NUMBER;

            //̑I摜ɂPanelGeometry_23Yԍi11`70j
            int endPhotoIndex = startPhotoIndex + MAX_PANEL_COUNT - 1;


            //e3Dplɉ摜Kp
            for (int i = startPhotoIndex; i <= endPhotoIndex; i++)
            {
                //plɕ\摜RNVCfbNXԍ
                int collectionIndex = GetPanalImageCollectionIndex(i, collectionCount);


                //\摜RNV擾
                Photo photo = viewPhotoCollection[collectionIndex];
                string photoImageUrl = photo.ImageUrl;

                //\Yf
                string geoModelName = MODEL_BASE_NAME + geoModelNumber;
                GeometryModel3D geoModel = (GeometryModel3D)this.FindName(geoModelName);

                //摜Bitmap擾
                BitmapImage image = photo.GetBitmap();

                //摜Kp
                SetImage(geoModel, image);

                //fpJEgAbv
                geoModelNumber++;
            }

        }


        /// <summary>
        /// plɕ\摜RNVCfbNXԍ擾
        /// </summary>
        /// <param name="index"></param>
        /// <param name="collectionCount"></param>
        /// <returns></returns>
        private int GetPanalImageCollectionIndex(int index, int collectionCount)
        {
            int collectionIndex = index;

            if (collectionIndex < 0)
            {
                //u0v菬ꍇɂ̓RNVŌォ
                int remainder = Math.Abs(collectionIndex) % collectionCount;
                if (remainder != 0)
                {
                    remainder = collectionCount - remainder;
                }
                collectionIndex = remainder;
            }
            else if (collectionIndex >= collectionCount)
            {
                //RNV𒴂ꍇɂ̓RNVŏ
                collectionIndex = collectionIndex % collectionCount;
            }

            return collectionIndex;
        }


        #region 3Dɉ摜\

        /// <summary>
        /// ݒSolidColorBrushImageBrushɕύX
        /// </summary>
        /// <param name="geometryModel">摜ZbgGeometryModel3D@PanelGeometry_X</param>
        /// <returns></returns>
        private ImageBrush CheckToImageBrush(GeometryModel3D geometryModel)
        {
            DiffuseMaterial geoMaterial = (DiffuseMaterial)geometryModel.Material;
            Brush materialBrush = geoMaterial.Brush;

            //Check Brush Type
            if (materialBrush is SolidColorBrush)
            {
                DiffuseMaterial cloneMaterial = (DiffuseMaterial)geoMaterial.Clone();
                geometryModel.Material = cloneMaterial;

                ImageBrush ib = new ImageBrush();
                ib.Stretch = Stretch.Uniform;

                cloneMaterial.Brush = ib;
            }

            //set again
            geoMaterial = (DiffuseMaterial)geometryModel.Material;

            return (ImageBrush)geoMaterial.Brush;
        }


        /// <summary>
        /// GeometryModel3Dɉ摜\i摜pXj
        /// </summary>
        /// <param name="geometryModel"></param>
        /// <param name="imagePath"></param>
        private void SetImage(GeometryModel3D geometryModel, String imagePath)
        {
            //check and get ImageBrush
            ImageBrush photoImageBrush = CheckToImageBrush(geometryModel);

            try
            {
                // bitmap
                BitmapImage bitmapImage = new BitmapImage();
                bitmapImage.BeginInit();

                Uri selLoc = new Uri(imagePath, UriKind.Absolute);
                bitmapImage.UriSource = selLoc;
                bitmapImage.EndInit();

                //set image
                photoImageBrush.ImageSource = bitmapImage;

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
        }


        /// <summary>
        /// GeometryModel3Dɉ摜\iBitmapImagej
        /// </summary>
        /// <param name="geometryModel"></param>
        /// <param name="bitmap"></param>
        private void SetImage(GeometryModel3D geometryModel, BitmapImage bitmap)
        {
            //check and get ImageBrush
            ImageBrush photoImageBrush = CheckToImageBrush(geometryModel);

            //set image
            photoImageBrush.ImageSource = bitmap;

        }

        #endregion


        #region 3DnZbgi{^ꂽj

        /// <summary>
        /// plɃZbgĂ摜
        /// </summary>
        private void ClearAllPanelBrush()
        {
            for (int i = 0; i < MAX_PANEL_COUNT; i++)
            {
                string geoModelName = MODEL_BASE_NAME + i;
                GeometryModel3D geoModel = (GeometryModel3D)this.FindName(geoModelName);
                //geoModel.Material = null;
                DiffuseMaterial geoMaterial = (DiffuseMaterial)geoModel.Material;
                if (geoMaterial.Brush is ImageBrush)
                {
                    ImageBrush photoImageBrush = (ImageBrush)geoMaterial.Brush;

                    photoImageBrush.ImageSource = null;
                }
            }
        }


        /// <summary>
        /// ModelContainerOffsetYʒuɂiXN[ׂ̈ɓւĂ邩j
        /// </summary>
        private void ResetContainerOffsetY()
        {
            for (int i = 0; i < MAX_PANEL_COUNT; i++)
            {
                string geoModelName = MODEL_GROUP_BASE_NAME + i;
                Model3DGroup geoModel = (Model3DGroup)this.FindName(geoModelName);
                Transform3DGroup group = (Transform3DGroup)geoModel.Transform;
                TranslateTransform3D transform = (TranslateTransform3D)group.Children[4];
                transform.OffsetY = -BASE_OFFSET_Y * i;
            }
        }


        /// <summary>
        /// pl̃XP[
        /// </summary>
        private void ResetContainerScale()
        {
            string currentGroupName = MODEL_GROUP_BASE_NAME + (modelSelectNumber).ToString();
            Model3DGroup currentModelGroup = (Model3DGroup)this.FindName(currentGroupName);

            //reset Model Scale
            DirectSetModelScale(currentModelGroup, MODEL_DEFALUT_SCALE, MODEL_DEFALUT_SCALE);
            DirectSetModelScale(photoGroup3D_12, MODEL_BIG_SCALE, MODEL_BIG_SCALE);
        }


        /// <summary>
        /// Aj[VȂŃf̃XP[ύX
        /// </summary>
        /// <param name="targetModelGroup"></param>
        /// <param name="scaleX"></param>
        /// <param name="scaleY"></param>
        private void DirectSetModelScale(Model3DGroup targetModelGroup, double scaleX, double scaleY)
        {
            Transform3DGroup tg = (Transform3DGroup)targetModelGroup.Transform;

            ScaleTransform3D scaleTransform = new ScaleTransform3D();

            scaleTransform.ScaleX = scaleX;
            scaleTransform.ScaleY = scaleY;
            scaleTransform.ScaleZ = 1;

            tg.Children[1] = scaleTransform;
        }

        #endregion


        #region 摜؂ւp

        /// <summary>
        /// Iʐ^𒆉ɕ\Aj[V
        /// </summary>
        /// <param name="prevNumber"></param>
        /// <param name="targetNumber"></param>
        private void TornadoAnimation(int prevNumber, int targetNumber)
        {
            Storyboard sb = (Storyboard)this.FindResource("Timeline_rotation");
            TimelineCollection tCollection = (TimelineCollection)sb.Children;

            //ModelContainer̊px
            Rotation3DAnimation rotateAnime = (Rotation3DAnimation)tCollection[0];
            AxisAngleRotation3D angleRotationTo = (AxisAngleRotation3D)rotateAnime.To;
            angleRotationTo.Angle = -BASE_ANGLE * scrollCount - 180;

            //ModelContaineȑ㉺ʒu
            DoubleAnimation offsetYAnime = (DoubleAnimation)tCollection[1];
            offsetYAnime.To = BASE_OFFSET_Y * scrollCount;


            //̃plXP[
            string prevGroupName = MODEL_GROUP_BASE_NAME + (prevNumber).ToString();

            DoubleAnimation smallAnimeX = (DoubleAnimation)tCollection[2];
            smallAnimeX.SetValue(Storyboard.TargetNameProperty, prevGroupName);
            smallAnimeX.To = MODEL_DEFALUT_SCALE;
            DoubleAnimation smallAnimeY = (DoubleAnimation)tCollection[3];
            smallAnimeY.SetValue(Storyboard.TargetNameProperty, prevGroupName);
            smallAnimeY.To = MODEL_DEFALUT_SCALE;


            //ṼplXP[
            string targetGroupName = MODEL_GROUP_BASE_NAME + (targetNumber).ToString();

            DoubleAnimation bigAnimeX = (DoubleAnimation)tCollection[4];
            bigAnimeX.SetValue(Storyboard.TargetNameProperty, targetGroupName);
            bigAnimeX.To = MODEL_BIG_SCALE;
            DoubleAnimation bigAnimeY = (DoubleAnimation)tCollection[5];
            bigAnimeY.SetValue(Storyboard.TargetNameProperty, targetGroupName);
            bigAnimeY.To = MODEL_BIG_SCALE;


            this.BeginStoryboard(sb);
        }


        #region E摜؂ւs


        /// <summary>
        /// ̉摜ցiẺ摜F]j
        /// </summary>
        private void ChangeToNextPhoto()
        {
            int collectionCount = viewPhotoCollection.Count;

            //Ẻ摜؂ւ
            scrollCount++;

            //I𒆂̉摜\Ă郂fԍ
            int prevNumber = modelSelectNumber;

            //[v\pɏֈړꍇ̉摜ւn܂RNṼCfbNXԍ擾
            int modelSwitchNumber = GetModelSwitchUpNumber(collectionCount);

            //̃fԍ
            modelSelectNumber++;
            if (modelSelectNumber >= MAX_PANEL_COUNT)
            {
                modelSelectNumber = 0;
            }


            //I𒆂̃RNV摜ԍ
            nowSelectNumber++;
            if (nowSelectNumber >= collectionCount)
            {
                nowSelectNumber = 0;
            }

            //I摜؂ւ
            TornadoAnimation(prevNumber, modelSelectNumber);

            //ڍ׃eLXgݒ
            SetPhotoText();


            //-----ȉ[vp-----


            //[vpɃpl̍W
            SwapLoopModel(1);

            //Ŵ̊Y摜Kp
            SwapLoopImage(modelSwitchNumber);

            //[vIĂl
            moveNumber++;
            if (moveNumber > MAX_PANEL_COUNT - 1)
            {
                moveNumber = 0;
            }

        }


        /// <summary>
        /// Ỏ摜ցỉ摜FE]j
        /// </summary>
        private void ChangeToPrevPhoto()
        {
            int collectionCount = viewPhotoCollection.Count;

            //Ẻ摜؂ւ
            scrollCount--;

            //I𒆂̉摜\Ă郂fԍ
            int prevNumber = modelSelectNumber;

            //[v\pɉֈړꍇ̉摜ւn܂RNṼCfbNXԍ擾
            int modelSwitchNumber = GetModelSwitchDownNumber(collectionCount);

            //̃fԍ
            modelSelectNumber--;
            if (modelSelectNumber < 0)
            {
                modelSelectNumber = MAX_PANEL_COUNT - 1;
            }


            //I𒆂̃RNV摜ԍ
            nowSelectNumber--;
            if (nowSelectNumber < 0)
            {
                nowSelectNumber = collectionCount - 1;
            }

            //I摜؂ւ
            TornadoAnimation(prevNumber, modelSelectNumber);

            //ڍ׃eLXgݒ
            SetPhotoText();


            //-----ȉ[vp-----


            //[vJnOɒl
            moveNumber--;
            if (moveNumber < 0)
            {
                moveNumber = MAX_PANEL_COUNT - 1;
            }

            //[vpɃpl̍W
            SwapLoopModel(-1);

            //Ŵ̊Y摜Kp
            SwapLoopImage(modelSwitchNumber);
        }

        #endregion


        #region [vXN[p

        /// <summary>
        /// [v\pɏֈړꍇ̉摜ւn܂RNṼCfbNXԍ擾
        /// </summary>
        /// <param name="collectionCount"></param>
        /// <returns></returns>

        private int GetModelSwitchUpNumber(int collectionCount)
        {
            //[v\pɏֈړꍇ̉摜ւn܂RNṼCfbNXԍ
            //iPanelGeometry_0ŉɈړĉ摜\RNVԍj
            int switchUpNumber = nowSelectNumber + 12;

            if (switchUpNumber >= collectionCount)
            {
                //RNV𒴂ꍇɂ̓RNVŏ̍
                switchUpNumber = switchUpNumber % collectionCount;
            }

            return switchUpNumber;
        }

        /// <summary>
        /// [v\pɉֈړꍇ̉摜ւn܂RNṼCfbNXԍ擾
        /// </summary>
        /// <param name="collectionCount"></param>
        /// <returns></returns>
        private int GetModelSwitchDownNumber(int collectionCount)
        {
            //[v\pɉֈړꍇ̉摜ւn܂RNṼCfbNXԍ
            //iPanelGeometry_23ŏ㕔Ɉړĉ摜\RNVԍj
            int switchDownNumber = nowSelectNumber - 13;

            if (switchDownNumber < 0)
            {
                //u0v菬ꍇɂ̓RNVŌォ
                int remainder = Math.Abs(switchDownNumber) % collectionCount;
                if (remainder != 0)
                {
                    remainder = collectionCount - remainder;
                }
                switchDownNumber = remainder;
            }

            return switchDownNumber;
        }

        /// <summary>
        /// [v\pɂ͂ݏopl̍W
        /// </summary>
        /// <param name="value"></param>
        private void SwapLoopModel(int value)
        {
            string groupName = MODEL_GROUP_BASE_NAME + moveNumber.ToString();
            Model3DGroup groupModel = (Model3DGroup)this.FindName(groupName);

            Transform3DGroup transformGroup = (Transform3DGroup)groupModel.Transform;
            TranslateTransform3D transform = (TranslateTransform3D)transformGroup.Children[4];
            double nowOffsetY = transform.OffsetY;
            //(24*1.5=36)
            double newOffsetY = nowOffsetY - (36 * value);
            transform.OffsetY = newOffsetY;
        }

        /// <summary>
        /// [v\̂߂ɍWpl̉摜ύX
        /// </summary>
        /// <param name="switchNumber"></param>
        private void SwapLoopImage(int switchNumber)
        {
            Photo photo = viewPhotoCollection[switchNumber];
            string photoImageUrl = photo.ImageUrl;

            //
            string geoModelName = MODEL_BASE_NAME + moveNumber;
            GeometryModel3D geoModel = (GeometryModel3D)this.FindName(geoModelName);

            BitmapImage image = photo.GetBitmap();
            SetImage(geoModel, image);
        }


        #endregion


        #region qbgeXg 摜؂ւ


        /// <summary>
        /// qbgeXge
        /// </summary>
        /// <param name="rawResult"></param>
        /// <returns></returns>
        private HitTestResultBehavior HTResultCallback(HitTestResult rawResult)
        {
            if (rawResult != null)
            {
                RayMeshGeometry3DHitTestResult rayMeshGeometryResutl = (RayMeshGeometry3DHitTestResult)rawResult;

                //
                if (rayMeshGeometryResutl != null)
                {
                    GeometryModel3D hitTargetModel = (GeometryModel3D)rayMeshGeometryResutl.ModelHit;

                    int hitModelNumber = 0;

                    //qbgeXgꂽf̃`FbN
                    for (int i = 0; i < MAX_PANEL_COUNT; i++)
                    {
                        string modelName = MODEL_BASE_NAME + i + "b";
                        GeometryModel3D geoModel = (GeometryModel3D)this.FindName(modelName);

                        if (hitTargetModel.Equals(geoModel))
                        {
                            hitModelNumber = i;
                            break;
                        }
                    }


                    //qbgeXgꂽfւ̃XN[
                    int changeValue = hitModelNumber - modelSelectNumber;

                    if (changeValue != 0)
                    {
                        if (changeValue > 7)
                        {
                            changeValue = changeValue - MAX_PANEL_COUNT;

                        }
                        else if (changeValue < -7)
                        {
                            changeValue = changeValue + MAX_PANEL_COUNT;
                        }

                        //qbgeXgŃXN[񐔂Ǘ
                        hitTestScrollValue = changeValue;

                        //qbgeXgp̃XN[^C}[Jn
                        SetHitTestSwitchTimer();
                    }
                }
            }

            return HitTestResultBehavior.Stop;
        }


        /// <summary>
        /// qbgeXgŃXN[^C}[N
        /// </summary>
        private void SetHitTestSwitchTimer()
        {
            //set Timer
            DispatcherTimer timer = new DispatcherTimer(TimeSpan.FromMilliseconds(SWITCHING_TIMER_SPAN),
                            DispatcherPriority.Background,//D揇
                            new EventHandler(this.TimerSwitching),//nh
                            this.Dispatcher);//݂̃fBXpb`

            //start timer
            timer.Start();
        }


        /// <summary>
        /// ^C}[TickŃXN[
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void TimerSwitching(object sender, EventArgs e)
        {
            //timer
            DispatcherTimer timer = (DispatcherTimer)sender;

            if (hitTestScrollValue > 0)
            {
                //next scroll
                ChangeToNextPhoto();
                hitTestScrollValue--;
            }
            else if (hitTestScrollValue < 0)
            {
                //prev scroll
                ChangeToPrevPhoto();
                hitTestScrollValue++;
            }
            else
            {
                timer.Stop();
            }

        }

        #endregion

        #endregion


        #endregion



        #region Method

        /// <summary>
        /// PhotoViewer\
        /// </summary>
        /// <param name="photoCollection"></param>
        /// <param name="selectNumber"></param>
        /// <param name="listPatternName"></param>
        public void Show(Collection<Photo> photoCollection, int selectNumber,string listPatternName)
        {
            //\摜̃RNVƑIԍZbg
            viewPhotoCollection = new Collection<Photo>();
            viewPhotoCollection = photoCollection;
            nowSelectNumber = selectNumber;


            //ڍ׃eLXgZbg
            listPattern = listPatternName;
            SetPhotoText();

            //XN[pJEg
            scrollCount = BASE_CENTER_MODEL_NUMBER;
            modelSelectNumber = BASE_CENTER_MODEL_NUMBER;

            //PhotoViewer\
            this.Visibility = Visibility.Visible;

            //3D\Aj[VN
            OpenTornadoAnimation(6, BASE_CENTER_MODEL_NUMBER);

        }


        #endregion


    }
}