using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using System.Windows.Media.Animation;

using ExtendSample.service;
using ExtendSample.service.hatena;
using ExtendSample.service.photozou;


namespace ExtendSample.view
{
    /// <summary>
    /// Interaction logic for SearchPanel.xaml
    /// </summary>

    public partial class SearchPanel : System.Windows.Controls.UserControl
    {

        #region JX^RoutedEvent

        #region {^NbNCxguSearchButtonClickedv

        /// <summary>
        /// JX^RoutedEventi{^NbNCxgjuSearchButtonClickedv쐬
        /// </summary>
        public static readonly RoutedEvent SearchButtonClickedEvent = EventManager.RegisterRoutedEvent("SearchButtonClicked", RoutingStrategy.Bubble, typeof(RoutedEventHandler), typeof(SearchPanel));

        // Provide CLR accessors for the event
        public event RoutedEventHandler SearchButtonClicked
        {
            add { AddHandler(SearchButtonClickedEvent, value); }
            remove { RemoveHandler(SearchButtonClickedEvent, value); }
        }

        // This method raises
        private void RaiseSearchButtonClickedEvent()
        {
            RoutedEventArgs newEventArgs = new RoutedEventArgs(SearchPanel.SearchButtonClickedEvent);
            RaiseEvent(newEventArgs);
        }

        #endregion

        #region S{^NbNCxguAllDeleteButtonClickedv

        /// <summary>
        /// JX^RoutedEventiS{^NbNCxgjuAllDeleteButtonClickedv쐬
        /// </summary>
        public static readonly RoutedEvent AllDeleteButtonClickedEvent = EventManager.RegisterRoutedEvent("AllDeleteButtonClicked", RoutingStrategy.Bubble, typeof(RoutedEventHandler), typeof(SearchPanel));

        // Provide CLR accessors for the event
        public event RoutedEventHandler AllDeleteButtonClicked
        {
            add { AddHandler(AllDeleteButtonClickedEvent, value); }
            remove { RemoveHandler(AllDeleteButtonClickedEvent, value); }
        }

        // This method raises
        private void RaiseAllDeleteButtonClickedEvent()
        {
            RoutedEventArgs newEventArgs = new RoutedEventArgs(SearchPanel.AllDeleteButtonClickedEvent);
            RaiseEvent(newEventArgs);
        }

        #endregion

        #endregion


        private IService activeService=null;
        private string searchWord = "";


        #region vpeB

        /// <summary>
        /// T[rX
        /// </summary>
        public IService ActiveService
        {
            get
            {
                return activeService;
            }
        }

        /// <summary>
        /// [h
        /// </summary>
        public string SearchWord
        {
            get
            {
                return searchWord;
            }
        }

        #endregion


        /// <summary>
        /// RXgN^
        /// </summary>
        public SearchPanel()
        {
            InitializeComponent();
        }


        #region Cxgnh


        /// <summary>
        /// SearchPanel[h@Cxgnh
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void userControl_Loaded(object sender, RoutedEventArgs e)
        {
            //Timeline_openIo^
            Storyboard openAnime = (Storyboard)this.FindResource("Timeline_open");
            openAnime.Completed += new EventHandler(OpenAnime_Completed);
        }


        /// <summary>
        /// plI[vAj[V@Cxgnh
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void OpenAnime_Completed(object sender, EventArgs e)
        {
            searchWordTextBox.Focus();
            openButton.IsEnabled = true;
        }


        #region {^@Cxgnh

        /// <summary>
        /// {^NbN@Cxgnh
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void SearchButton_Click(object sender, RoutedEventArgs e)
        {
            //NbNꂽ{^擾
            FrameworkElement feSource = e.Source as FrameworkElement;
            Button searchButton = (Button)feSource;

            //{^ɂЂÂT[rX擾
            IService service = (IService)searchButton.Tag;

            //N
            SearchAction(service);
        }

        /// <summary>
        /// uDelete Allv{^NbN@Cxgnh
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void deleteButton_Click(object sender, RoutedEventArgs e)
        {
            //S{^NbNCxguAllDeleteButtonClickedv
            RaiseAllDeleteButtonClickedEvent();
        }


        #region plJ{^NbN@Cxgnh@iplXChŃeLXǵE{^̃tH[JXcĂ܂̂Uj


        /// <summary>
        /// pl{^NbN@Cxgnh
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void closeButton_Click(object sender, RoutedEventArgs e)
        {
            closeButton.Focus();
        }


        /// <summary>
        /// plJ{^NbN@Cxgnh
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void openButton_Click(object sender, RoutedEventArgs e)
        {
            openButton.Focus();
        }


        #endregion


        #endregion


        #endregion


        #region private Method

        /// <summary>
        /// N
        /// </summary>
        /// <param name="buttonService"></param>
        private void SearchAction(IService buttonService)
        {
            //ɎgpT[rXƃL[[h擾
            activeService = buttonService;
            searchWord = searchWordTextBox.Text;

            //{^NbNCxguSearchButtonClickedv
            RaiseSearchButtonClickedEvent();
        }


        #endregion



        #region Method

        /// <summary>
        /// plI[vNiftHgTlCT[N\j
        /// </summary>
        public void KickOpenAnimation()
        {
            Storyboard openAnime = (Storyboard)this.FindResource("Timeline_open");
            this.BeginStoryboard(openAnime);
        }


        /// <summary>
        /// ftHgN
        /// </summary>
        public void KickOpeningSearch()
        {
            //ftHgpT[rX
            IService firstSearchService = new Photozou();

            //
            SearchAction(firstSearchService);
        }

        #endregion


    }
}