﻿using System;
using System.IO;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Navigation;
using System.Windows.Media.Media3D;
using System.Windows.Input;

namespace CubeWithHitTestSample
{
	public partial class Window1
	{
		public Window1()
		{
			this.InitializeComponent();
			
			// Insert code required on object creation below this point.
		}

		private void ZAM3DViewport3D_MouseDown(object sender, System.Windows.Input.MouseButtonEventArgs e)
		{
			this.HitTestImage3D();
		}

		#region HitTest

		/// <summary>
		/// ZAM3DViewport3D をヒットテストします。
		/// </summary>
		protected void HitTestImage3D()
		{
			// ZAM3DViewport3D 上のマウス座標を取得します。
			Point mousePosition = Mouse.GetPosition(this.ZAM3DViewport3D);
			// マウス座標から オブジェクトのヒットテストに使用するパラメータを作成します。
			PointHitTestParameters pointparams = new PointHitTestParameters(mousePosition);
			// ヒットテストのコールバックとパラメータを指定して、ヒットテストを実行します。
			VisualTreeHelper.HitTest(this.ZAM3DViewport3D, null, this.Viewport3DHitTestResultCallback, pointparams);
		}

		/// <summary>
		/// ZAM3DViewport3D のヒットテストのコールバック。
		/// </summary>
		/// <param name="result">ヒットテストの結果。</param>
		/// <returns>ヒットテストの結果。</returns>
		protected HitTestResultBehavior Viewport3DHitTestResultCallback(HitTestResult result)
		{
			RayHitTestResult rayResult = result as RayHitTestResult;

			if (rayResult != null)
			{
				RayMeshGeometry3DHitTestResult rayMeshResult = rayResult as RayMeshGeometry3DHitTestResult;

				if (rayMeshResult != null)
				{
					GeometryModel3D hitgeo = rayMeshResult.ModelHit as GeometryModel3D;
					if (hitgeo != null)
					{
						this.OnModelClicked(hitgeo);
					}
				}
			}
			// 一つ目のオブジェクトにヒットした後は何もしない。
			return HitTestResultBehavior.Stop;
		}

		/// <summary>
		/// GeometryModel3D がクリックされたときの処理を記述します。
		/// </summary>
		/// <param name="model">クリックされた GeometryModel3D 。</param>
		protected void OnModelClicked(GeometryModel3D model)
		{
			if (model == this.Box01OR9GR10)
			{
				MessageBox.Show("Hello, Forward Cube!");
			}
			else if (model == this.Box01OR9GR1)
			{
				MessageBox.Show("Hello, Backward Cube!");
			}
		}

		#endregion
	}
}